#!/bin/bash 

#------------------------------------
#输入窗口的ID号和资源名字(软件名)，产生叠加了软件图标的窗口缩略图片。 
#parameter:	$[w.id] $[w.class] $[w.resource]
#author:	eexpress
#version:	3
#------------------------------------
icon_width=128
ini_file="${fvwm_files}/thumbnail.ini"
base_path="${thumbnail}/thumbnail"
app="$2"
#产生基本的缩略图。
xwd -silent -id $1 | convert -scale $[icon_width] xwd:- png:${base_path}.png 

if [ -f "${ini_file}" ]; then
	p=`awk -F, '/'$app'/ {print $2; exit}' ${ini_file}`
#	p=${p#*,}
	if [ -f "$p" ]; then 
	composite -compose over "$p" "${base_path}.png" "${base_path}.${1}.png"
		exit
	else
		mv ${ini_file} ${base_path}.ini.old
		sed '/'$app'/d' ${base_path}.ini.old>${ini_file}
	fi
fi

#app=`echo $2|tr '[:upper:]' '[:lower:]'` 
p=`locate -r "\<${app}\.\(xpm\|png\)" -q -i -n 1`
#p=`locate $app.png $app.xpm|grep '/usr/share'|grep '\/${app}.'|head -n 1`
#p=`locate -i -q /usr/share/*/$app.png /usr/share/*/$app.xpm|head -n 1`
#p=`locate -i -q /usr/share/*/$2.png /usr/share/*/$2.xpm /usr/share/*/$3.png /usr/share/*/$3.xpm|head -n 1`
if [ -f "$p" ]; then
	composite -compose over $p ${base_path}.png ${base_path}.${1}.png
	echo $2,$p>>${ini_file}
	exit
fi

#最后的措施：用文字图片叠加显示。
convert -background none -fill blue -font Bookman-DemiItalic -pointsize 20 label:${2} ${thumbnail}/auto-text.png
composite -compose over ${thumbnail}/auto-text.png ${base_path}.png ${base_path}.${1}.png

#---------------------------------------文件结束
